package jp.sourceforge.freegantt.data.model;

import java.util.ArrayList;
import java.util.List;

import javax.swing.ComboBoxModel;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;

import jp.sourceforge.freegantt.data.Member;
import jp.sourceforge.freegantt.data.Project;

public class TaskMemberComboBoxModel implements ComboBoxModel {

	Project project;
	Member selection = null;
	List<ListDataListener> listDataListeners = new ArrayList<ListDataListener>();
	
	public TaskMemberComboBoxModel(Project project) {
		this.project = project;
	}
	
	@Override
	public int getSize() {
		return project.getMembers().size() + 1;
	}

	@Override
	public Object getElementAt(int index) {
		if (index == 0) return null;
		return project.getMembers().get(index - 1);
	}

	@Override
	public void addListDataListener(ListDataListener l) {
		listDataListeners.add(l);
	}

	@Override
	public void removeListDataListener(ListDataListener l) {
		listDataListeners.remove(l);
	}

	@Override
	public void setSelectedItem(Object anItem) {
		selection = (Member)anItem;
	}

	@Override
	public Object getSelectedItem() {
		return selection;
	}
	
	public void fireListDataListener() {
		for (ListDataListener l: listDataListeners) {
			ListDataEvent e = new ListDataEvent(this, ListDataEvent.CONTENTS_CHANGED, 0, 0);
			l.contentsChanged(e);
		}
	}

}
